#include <iostream>
#include <typeinfo>
#include <type_traits>

class A {
public:
	// virtual ~A(); // 'A' *IS NOT* polymorphic!
	using Internal_type = A; // For simplification, but stupid...
};

class Note {
	virtual void initialization() {/* No code for simplification*/ };
};

class Confidential_note : public Note {
	void initialization() override {/* No code for simplification*/ };
};

template <typename T> // 'my_function' has to work with a polymorphic type...
// Return type is 'void' due to 'std::enable_if_t' inference succeeds:
typename std::enable_if_t<std::is_polymorphic_v<T> > my_function(T&&) { std::cout << "Base" << std::endl; }; // C++17 required
// Specialization of 'my_function':
template <typename T> void my_function(typename T::Internal_type&&) { std::cout << "Specialization, SFINAE" << std::endl; };

int main() {
	::my_function<A>(A()); // 'Specialization, SFINAE'
	::my_function<Note>(Note()); // 'Base'
	::my_function<Confidential_note>(Confidential_note()); // 'Base'
	// ::my_function("'std::string' is not a polymorphic type..."); // Compilation error...
}